/**CHeaderFile*****************************************************************

  FileName    [ustring.h]

  PackageName [utils]

  Synopsis    [Routines to handle with strings.]

  Description [Routines to handle with strings, in order to maintain
  an unique instance of each string.]

  Author      [Marco Roveri]

  Copyright   [ Copyright (c) 1998 by ITC-IRST and Carnegie Mellon University.
  All Rights Reserved. This software is for educational purposes only.
  Permission is given to academic institutions to use, copy, and modify
  this software and its documentation provided that this introductory
  message is not removed, that this software and its documentation is
  used for the institutions' internal research and educational purposes,
  and that no monies are exchanged. No guarantee is expressed or implied
  by the distribution of this code.
  Send bug-reports and/or questions to: nusmv@irst.itc.it. ]

  Revision    [$Id: $]

******************************************************************************/
#ifndef _U_STRING_H
#define _U_STRING_H

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/
typedef struct string_ {
  struct string_ *link;
  char *text;
} string_rec;

typedef struct string_ *string_ptr;

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/
#define str_get_text(_s_) _s_->text

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/
EXTERN void init_string ARGS((void));
EXTERN string_ptr find_string ARGS((char *));
EXTERN char * get_text ARGS((string_ptr str));

#endif /* _U_STRING_H */
